package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.FXTIC;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

import static org.ssssssss.magicboot.zdyutils.FXTIC.TESTERPURL;

/**
 * 人员同步
 */
@RestController
@RequestMapping("/Cost")

public class CostController {
    private final Logger log = LoggerFactory.getLogger(CostController.class);

    public static void main(String[] args) throws Exception {


        new CostController().getCostData();

    }

    @PostMapping("/getCostData")
    public void getCostData() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String starttime = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60 * 24));
        String endtime = sdf.format(System.currentTimeMillis() );
        System.out.println(starttime);
        System.out.println(endtime);
        String sendUrl = TESTERPURL+"/v2/f9w5/cal/calCost/queryCostByTime";
        Map<String, String> headers = new HashMap<String, String>();
       String accessToken = new KDTokenController().getKDAccessTokenTest();
        if (accessToken == null || accessToken.equals("")) {
            log.info("金蝶token为空或不存在");
            return;
        }

        starttime = "2025-05-28 00:00:00";
        endtime = "2025-05-30 00:00:00";

        headers.put("accessToken", accessToken);//放token
        JSONObject params = new JSONObject();
        params.put("starttime", starttime);
        params.put("endtime", endtime);

        HttpClientResult rtn = HttpClientUtils.doPostJson(sendUrl, headers, params.toJSONString());
        String resStr = rtn.getContent();
        JSONObject resjs = JSONObject.parseObject(resStr);
        if (resjs != null) {
            if ("0".equals(resjs.getString("errorCode"))) {//查询成功

                JSONArray resJson = resjs.getJSONArray("data");
                System.out.println("待更新成本数量" + resJson.size());

                for (int i = 0; i < resJson.size(); i++) {
                    XKTokenAccess xktonken = new XKTokenAccess();
                    JSONObject str = resJson.getJSONObject(i);

                    Object cost = GcjJson.getNodeValue(str, "JSON.cost") != null ? GcjJson.getNodeValue(str, "JSON.cost") : "0.0000000000";
                    //物料编码
                    String number = GcjJson.getNodeValue(str, "JSON.materialnum") != null ? GcjJson.getNodeValue(str, "JSON.materialnum").toString() : "";

                    String crmcost = "0.0000000000";

                    if (cost != null) {
                        try {
                            BigDecimal costBigDecimal = new BigDecimal(cost.toString());
                            crmcost= costBigDecimal.stripTrailingZeros().toPlainString();
                        } catch (NumberFormatException e) {
                            e.printStackTrace();
                        }
                    }


                    String syn_type = "0";//同步类型 0新增 1修改 2删除
                    log.info("-------------------开始执行物料成本" + i + " -------------------" + number);
                    XxlJobHelper.log("-------------------开始执行物料成本" + i + " -------------------" + number);

                    Boolean sendFlag = false;
                    StringBuffer stringBuffer = new StringBuffer();

                    try {
                        boolean tbflag = false;
                        //验证数据是否已存在
                        //查询CRM物料
                        String crmId = fxapi.getDataBYID("ProductObj", "name", number, "JSON.data.dataList[0]._id");
                        if (crmId == null || "".equals(crmId)) {
                            continue;
                        }

                        JSONObject obj = new JSONObject();
                        LinkedHashMap map = new LinkedHashMap<String, Object>();
                        map.put("body.data.object_data._id", crmId);
                        map.put("body.data.object_data.field_9fU2M__c", crmcost);
                        map.put("body.data.object_data.dataObjectApiName", "ProductObj");

                        map.put("body.corpId", FXTIC.CORPID);
                        map.put("body.corpAccessToken", xktonken.getCorpAccessToken().getCorpAccessToken());
                        map.put("body.currentOpenUserId", FXTIC.CURRENTOPENUSERID);
                        for (Object key : map.keySet()) {
                            GcjJson.setNodeValue(obj, key.toString(), map.get(key));
                        }
                        log.info("--请求json---" + obj);
                        String res_url = "";
                        String res_param = "";
                        String res = "";
                        try {

                                syn_type = "1";
                                res = fxapi.updateV2Obj(obj);
                                res_url = FXTIC.URL_FX_UPDATE;

                            res_param = obj.toJSONString();
                            log.info("返回值：" + res);
                            JSONObject datajs = JSON.parseObject(res);
                            if (datajs != null && "0".equals(datajs.getString("errorCode"))) {

                            } else {
                                sendFlag = true;
                                stringBuffer.append(datajs.getString("errorMessage") + "");
                            }
                        } catch (Exception e) {
                            sendFlag = true;
                            stringBuffer.append("纷享销客接口调用失败,请检查网络配置");
                        }

                        JSONObject logData = new JSONObject();
                        logData.put("log_type", "productcost"); //业务类型
                        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
                        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
                        logData.put("data_id", crmId);//数据id
                        logData.put("data_name", number);//数据名称
                        logData.put("res_body", "同步成功");//返回值
                        logData.put("res_url", res_url);//
                        logData.put("res_param", res_param);//
                        logData.put("res_res", res);//
                        if (sendFlag) {
                            logData.put("res_body", stringBuffer.toString());//返回值
                        }
                        //写入传输日志
                        MagicApi.saveCostLog(logData);



                    } catch (Exception e) {
                        continue;
                    }

                }


            }
        }

    }




}
