package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.constant.ERPURLConstant;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/intentionPrediction")
public class intentionPredictionController {
    static Logger log = LoggerFactory.getLogger("intentionPrediction");

    public static void main(String[] args) throws Exception {
            new intentionPredictionController().getSynDataAdd();
            new intentionPredictionController().SynSave();
      //  new intentionPredictionController().getClose();
    }

    public void getClose()throws Exception{
        FXHTTP fxapi = new FXHTTP();
        String apiName = "intention_prediction__c";
        String[] arr ={"option_close_success__c","option_failure_to_close__c"};

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("ISN", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "sales_prediction_status__c", "option_is_closed__c"),
                new CrmFXApiParam("NIN", "closed_status__c", arr),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );
        JSONObject jsonject = fxapi.getSynNewDataObj(true, "意向预测关闭", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");
        if(array.isEmpty()){
            return;
        }
        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String erp_organization__c = GcjJson.getNodeValue(str, "JSON.erp_organization__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization__c").toString() : "";

            Boolean sendFlag = false;
            JSONObject params = new JSONObject();
            String strJson = "";
            JSONArray dataarr = new JSONArray();
            JSONObject datajson = new JSONObject();
            String cemployeeid = "";
            if (GcjJson.getNodeValue(str, "JSON.owner__r.id") != null) {
                cemployeeid = GcjJson.getNodeValue(str, "JSON.owner__r.id").toString();
                cemployeeid = fxapi.getDataBYID("PersonnelObj", "_id", cemployeeid, "JSON.data.dataList[0].field_T1xid__c");
            }

            String cdeptid = "";
            if (GcjJson.getNodeValue(str, "JSON.owner_department_id") != null) {
                String dept_id = GcjJson.getNodeValue(str, "JSON.owner_department_id").toString();
                cdeptid = fxapi.getDataBYID("DepartmentObj", "dept_id", dept_id, "JSON.data.dataList[0].field_Vj6sf__c");
            }

            //统一社会信用代码
            datajson.put("billno",nameData);
            datajson.put("billstatus","C");//状态
            datajson.put("f9w5_busstatus","B");//状态  关闭默认为B
            datajson.put("f9w5_billtypefield_number","f9w5_sm_predict_BT");//状态
            datajson.put("f9w5_crmid",dataId);//CRMID
            datajson.put("f9w5_userdept_number",cdeptid);
            datajson.put("f9w5_user_number",cemployeeid);
            datajson.put("f9w5_org_number",erp_organization__c);//组织

            dataarr.add(datajson);
            params.put("data",dataarr);
            log.info("--请求json---" + params.toJSONString());
            System.out.println("--请求json:---" +params.toJSONString());
            strJson = params.toJSONString();
            StringBuffer stringBuffer = new StringBuffer();
            String syn_type = "2";//同步类型 0新增 1修改 2关闭
            String res_url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/sm/f9w5_sm_predict/smPredictSave";
            String res_param = params.toJSONString();
            String res = "";
            try {
                // String accessToken = "2096108315279888384_8elReBSzvx315JiLWiH82YKJGosF3G2kN688q05rHUritX9x3fWS3lmetalPeMe3HceZV7fK1GdSJsk1J46A3S0VkOxIUqf7wnS207";
                String accessToken = new KDTokenController().getKDAccessTokenTest();

                Map<String, String> headers = new HashMap<String, String>();
                headers.put("accessToken",  accessToken);//放token
                HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, strJson);
                String resStr =  rtn.getContent();
                JSONObject resjs = JSONObject.parseObject(resStr);
                res = resStr;
                if (resjs != null && resjs.getBoolean("status")) {
                    JSONObject successdata  =  resjs.getJSONObject("data");
                    JSONArray result = successdata.getJSONArray("result");
                    JSONObject erpdata = (JSONObject) result.get(0);
                    String erpid = erpdata.getString("id");

                    Map<String, Object> paramMap = new HashMap<String, Object>();
                  //  paramMap.put("erp_id__c", erpid);//数据ID
                    paramMap.put("closed_status__c", "option_close_success__c");
                    paramMap.put("sync_info__c", "ERP已关闭");
                    //回写json
                    fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
                }else{
                    sendFlag=true;
                    stringBuffer.append("意向预测关闭接口调用失败:"+resjs.getString("message"));
                    Map<String, Object> paramMap = new HashMap<String, Object>();
                    paramMap.put("closed_status__c", "option_failure_to_close__c");
                    paramMap.put("sync_info__c", stringBuffer);
                    //回写json
                    fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
                }
            } catch (Exception e) {
                sendFlag = true;
                stringBuffer.append("意向预测关闭接口调用失败,请检查网络配置");
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("closed_status__c", "option_failure_to_close__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
            }

            JSONObject logData = new JSONObject();
            logData.put("log_type", "IPclose"); //业务类型
            logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
            logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
            logData.put("data_id", dataId);//数据id
            logData.put("data_name", nameData);//数据名称
            logData.put("res_body", "同步成功");//返回值
            logData.put("res_url", res_url);//
            logData.put("res_param", res_param);//
            logData.put("res_res", res);//
            if (sendFlag) {
                logData.put("res_body", stringBuffer.toString());//返回值
            }
            //写入传输日志
            MagicApi.saveSPLog(logData);


        }

    }

    public void getSynDataAdd() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "intention_prediction__c";
        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 12)),
                new CrmFXApiParam("IS", "erp_id__c", ""),
                  new CrmFXApiParam("GT", "create_time", "1748923200000"),
                new CrmFXApiParam("EQ", "sync_status__c", "option_pending_sync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );


       //    List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "YXYC2506050001"));

        JSONObject jsonject = fxapi.getSynNewDataObj(true, "意向预测", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");
        List<CrmFXApiParam> paramListB = Arrays.asList(
                new CrmFXApiParam("EQ", "sync_status__c", "option_resync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );
        JSONObject jsonjectB = fxapi.getSynNewDataObj(true, "意向预测重新同步", apiName, paramListB);
        JSONArray arrayA = jsonjectB.getJSONObject("data").getJSONArray("dataList");
        array.addAll(arrayA);




        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";

            String syn_type = "0";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行意向预测" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行意向预测" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataSP("IP", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                    if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                        tbflag = false;
                    }

                }
                if (tbflag) {
                    continue;
                }
                log.info("意向预测待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "IP"); //业务类型
                jsonObjectData.put("send_syn", "0"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDataSP(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void SynSave() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/querysales_prediction?sendType=IP&sendStatus=3&sendSyn=0", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步意向预测数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
               String remark = GcjJson.getNodeValue(str, "JSON.remark__c") != null ? GcjJson.getNodeValue(str, "JSON.remark__c").toString() : "";
                String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
                String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";


                String erp_organization__c = GcjJson.getNodeValue(str, "JSON.erp_organization__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization__c").toString() : "";

                String cemployeeid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner__r.id") != null) {
                    cemployeeid = GcjJson.getNodeValue(str, "JSON.owner__r.id").toString();
                    cemployeeid = fxapi.getDataBYID("PersonnelObj", "_id", cemployeeid, "JSON.data.dataList[0].field_T1xid__c");
                }

                String cdeptid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner_department_id") != null) {
                    String dept_id = GcjJson.getNodeValue(str, "JSON.owner_department_id").toString();
                    cdeptid = fxapi.getDataBYID("DepartmentObj", "dept_id", dept_id, "JSON.data.dataList[0].field_Vj6sf__c");
                }
                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataSP("IP", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                        if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                            tbflag = false;
                        }
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    //统一社会信用代码
                    datajson.put("billno",nameData);
                    //提出时间
                    datajson.put("createtime",sdf.format(GcjJson.getNodeValue(str, "JSON.proposal_date__c")));
                    datajson.put("f9w5_remark",remark);//备注

                    datajson.put("f9w5_userdept_number",cdeptid);
                    datajson.put("f9w5_user_number",cemployeeid);
                    datajson.put("f9w5_billtypefield_number","f9w5_sm_predict_BT");//状态
                    datajson.put("f9w5_crmid",dataId);//CRMID
                    datajson.put("billstatus","C");//状态
                    datajson.put("f9w5_busstatus","A");//状态  新增默认为正常

                    datajson.put("f9w5_org_number",erp_organization__c);//组织

                    JSONArray billentry = new JSONArray();


                    String apiNameZ = "intention_prediction_details__c";
                    JSONObject jsonjectZ = fxapi.getSynDataZDYObj("意向预测明细", apiNameZ, "intention_prediction__c", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    for (int j = 0; j < arrayZ.size(); j++) {
                        JSONObject stra = arrayZ.getJSONObject(j);
                        JSONObject billentryjson = new JSONObject();
                          billentryjson.put("f9w5_qty", GcjJson.getNodeValue(stra, "JSON.quantity__c"));
                        billentryjson.put("f9w5_deliverydate",sdf.format(GcjJson.getNodeValue(stra, "JSON.required_delivery_time__c")));
                        billentryjson.put("f9w5_others", GcjJson.getNodeValue(stra, "JSON.other_requirements__c"));

                        billentryjson.put("f9w5_business", GcjJson.getNodeValue(stra, "JSON.opportunity_name_text__c"));
                        billentryjson.put("f9w5_province",GcjJson.getNodeValue(stra, "JSON.province__c"));

                        billentryjson.put("f9w5_prosys_number",GcjJson.getNodeValue(stra, "JSON.product_type__c"));

                        billentryjson.put("f9w5_crmentryid",GcjJson.getNodeValue(stra, "JSON._id"));
                        //billentryjson.put("material_number","10010020374");
                        billentry.add(billentryjson);

                    }
                    datajson.put("entryentity",billentry);//意向预测明细

                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/sm/f9w5_sm_predict/smPredictSave";
        String res_param = obj;
        String res = "";
        try {
           // String accessToken = "2096108315279888384_8elReBSzvx315JiLWiH82YKJGosF3G2kN688q05rHUritX9x3fWS3lmetalPeMe3HceZV7fK1GdSJsk1J46A3S0VkOxIUqf7wnS207";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");

                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("erp_id__c", erpid);//数据ID
                paramMap.put("sync_status__c", "option_sync_success__c");
                paramMap.put("sync_info__c", "同步完成");
                //回写json
                fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
            }else{
                sendFlag=true;
                stringBuffer.append("意向预测创建接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("意向预测创建接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATESP(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "IP"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveSPLog(logData);
    }


    //修改
    public void getSynDataAddUPdate() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "intention_prediction__c";
        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 8)),
                new CrmFXApiParam("ISN", "erp_id__c", ""),
                new CrmFXApiParam("EQ", "sales_prediction_status__c", "option_not_closed__c"),
                new CrmFXApiParam("GT", "create_time", "1748923200000"),
                new CrmFXApiParam("EQ", "sync_status__c", "option_sync_success__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );


        //    List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "YXYC2506050001"));

        JSONObject jsonject = fxapi.getSynNewDataObj(true, "意向预测修改", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";

            String syn_type = "1";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行意向预测修改" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行意向预测修改" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataSP("IP", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))  && endtime.equals(dataSyn.getString("mark")) ) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;

                }
                if (tbflag) {
                    continue;
                }
                log.info("意向预测待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "IP"); //业务类型
                jsonObjectData.put("send_syn", "1"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDataSP(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }
    public void SynUpdate() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/querysales_prediction?sendType=IP&sendStatus=3&sendSyn=1", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步意向预测数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "1";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
                String remark = GcjJson.getNodeValue(str, "JSON.remark__c") != null ? GcjJson.getNodeValue(str, "JSON.remark__c").toString() : "";
                String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
                String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";


                String erp_organization__c = GcjJson.getNodeValue(str, "JSON.erp_organization__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_organization__c").toString() : "";

                String cemployeeid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner__r.id") != null) {
                    cemployeeid = GcjJson.getNodeValue(str, "JSON.owner__r.id").toString();
                    cemployeeid = fxapi.getDataBYID("PersonnelObj", "_id", cemployeeid, "JSON.data.dataList[0].field_T1xid__c");
                }

                String cdeptid = "";
                if (GcjJson.getNodeValue(str, "JSON.owner_department_id") != null) {
                    String dept_id = GcjJson.getNodeValue(str, "JSON.owner_department_id").toString();
                    cdeptid = fxapi.getDataBYID("DepartmentObj", "dept_id", dept_id, "JSON.data.dataList[0].field_Vj6sf__c");
                }
                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataSP("IP", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))  && endtime.equals(dataSyn.getString("mark")) ) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;

                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    //统一社会信用代码
                    datajson.put("billno",nameData);
                    //提出时间
                    datajson.put("createtime",sdf.format(GcjJson.getNodeValue(str, "JSON.proposal_date__c")));
                    datajson.put("f9w5_remark",remark);//备注

                    datajson.put("f9w5_userdept_number",cdeptid);
                    datajson.put("f9w5_user_number",cemployeeid);
                    datajson.put("f9w5_billtypefield_number","f9w5_sm_predict_BT");//状态
                    datajson.put("f9w5_crmid",dataId);//CRMID
                    datajson.put("billstatus","C");//状态
                    datajson.put("f9w5_busstatus","A");//状态  新增默认为正常

                    datajson.put("f9w5_org_number",erp_organization__c);//组织

                    JSONArray billentry = new JSONArray();


                    String apiNameZ = "intention_prediction_details__c";
                    JSONObject jsonjectZ = fxapi.getSynDataZDYObj("意向预测明细", apiNameZ, "intention_prediction__c", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    for (int j = 0; j < arrayZ.size(); j++) {
                        JSONObject stra = arrayZ.getJSONObject(j);
                        JSONObject billentryjson = new JSONObject();
                        billentryjson.put("f9w5_qty", GcjJson.getNodeValue(stra, "JSON.quantity__c"));
                        billentryjson.put("f9w5_deliverydate",sdf.format(GcjJson.getNodeValue(stra, "JSON.required_delivery_time__c")));
                        billentryjson.put("f9w5_others", GcjJson.getNodeValue(stra, "JSON.other_requirements__c"));

                        billentryjson.put("f9w5_business", GcjJson.getNodeValue(stra, "JSON.opportunity_name_text__c"));
                        billentryjson.put("f9w5_province",GcjJson.getNodeValue(stra, "JSON.province__c"));

                        billentryjson.put("f9w5_prosys_number",GcjJson.getNodeValue(stra, "JSON.product_type__c"));

                        billentryjson.put("f9w5_crmentryid",GcjJson.getNodeValue(stra, "JSON._id"));

                        billentry.add(billentryjson);

                    }
                    datajson.put("entryentity",billentry);//意向预测明细

                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSaveUpdate(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }


    public void getSynDataSaveUpdate(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "1";//同步类型 0新增 1修改 2删除
        String res_url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/sm/f9w5_sm_predict/smPredictSave";
        String res_param = obj;
        String res = "";
        try {
            // String accessToken = "2096108315279888384_8elReBSzvx315JiLWiH82YKJGosF3G2kN688q05rHUritX9x3fWS3lmetalPeMe3HceZV7fK1GdSJsk1J46A3S0VkOxIUqf7wnS207";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");

            }else{
                sendFlag=true;
                stringBuffer.append("意向预测修改接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("意向预测修改接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynZDYFieldParam("", "intention_prediction__c", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATESP(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "IP"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveSPLog(logData);
    }




}
