package org.ssssssss.magicboot.zdyutils;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

public class GcjJson {
    /**
     * 获取节点值
     * @param jsonPath
     * @return
     * @throws Exception
     */
    public static synchronized Object getNodeValue(JSONObject obj, String jsonPath) throws Exception {
        String[] nodes = jsonPath.split("\\.");

        for (int i = 1; i < nodes.length; i++) {
            if (obj != null) {
                obj = getObj(obj, nodes[i]);
            }
            if ((i+1) == nodes.length) {
                try {
                    return obj.get(nodes[i]);
                } catch(Exception e) {
                    //return "JSONException:" + e.getMessage() + ", NodeString:" + obj.toString();
                    return null;
                }
            }
        }
        return null;
    }
    /**
     * 获取节点值
     * @param jsonPath
     * @return
     * @throws Exception
     */
    public static synchronized String getNodeStrValue(JSONObject obj, String jsonPath) throws Exception {
        String[] nodes = jsonPath.split("\\.");

        for (int i = 1; i < nodes.length; i++) {
            if (obj != null) {
                obj = getObj(obj, nodes[i]);
            }
            if ((i+1) == nodes.length) {
                try {
                    return obj.get(nodes[i])+"";
                } catch(Exception e) {
                    //return "JSONException:" + e.getMessage() + ", NodeString:" + obj.toString();
                    return "";
                }
            }
        }
        return "";
    }
    /**
     * 对节点进行解析
     *
     * @param obj
     * @param node
     * @return
     */
    private static JSONObject getObj(JSONObject obj, String node) {
        try {
            if(node.contains("[")) {
                JSONArray arr = obj.getJSONArray(node.substring(0, node.indexOf("[")));
                for(int i = 0; i < arr.size(); i++) {
                    if ((i + "").equals(node.substring(node.indexOf("["), node.indexOf("]")).replace("[", ""))) {
                        return arr.getJSONObject(i);
                    }
                }
            } else {
                return obj.getJSONObject(node);
            }
        } catch(Exception e) {
            return obj;
        }
        return null;
    }
    public static String detailString(JSONObject jsonp, String getValue, String unitlabasdal) {
        JSONArray objUnit = new JSONArray();
        String unitlabal = "";
        objUnit = jsonp.getJSONObject("data").getJSONObject("describe").getJSONObject("fields").getJSONObject(getValue).getJSONArray("options");
        //循环遍历  获取id 对应的值
        for (int i = 0; i < objUnit.size(); i++) {
            if (objUnit.getJSONObject(i).getString("value") != null && objUnit.getJSONObject(i).getString("value").equals(unitlabasdal)) {
                unitlabal = objUnit.getJSONObject(i).getString("label");
                break;
            }
        }
        return unitlabal;
    }
    public static String detailStrVal(JSONObject jsonp, String getValue, String unitlabasdal) {
        JSONArray objUnit = new JSONArray();
        String unitlabal = "";
        objUnit = jsonp.getJSONObject("data").getJSONObject("describe").getJSONObject("fields").getJSONObject(getValue).getJSONArray("options");
        //循环遍历  获取id 对应的值
        for (int i = 0; i < objUnit.size(); i++) {
            if (objUnit.getJSONObject(i).getString("label") != null && objUnit.getJSONObject(i).getString("label").equals(unitlabasdal)) {
                unitlabal = objUnit.getJSONObject(i).getString("value");
                break;
            }
        }
        return unitlabal;
    }
    public static synchronized void setNodeValue(JSONObject obj, String jsonPath, Object value) throws Exception {
        String[] nodes = jsonPath.split("\\.");
        for (int i = 1; i < nodes.length; i++) {
            if ((i + 1) == nodes.length) {
                try {

                    if (nodes[i].contains("[")) {
                        String nodesIndexS=nodes[i];
                        int leftIndex = nodesIndexS.indexOf("[");  // 获取左中括号的位置
                        int rightIndex = nodesIndexS.indexOf("]");  // 获取右中括号的位置
                        int num =0;
                        if (leftIndex != -1 && rightIndex != -1) {
                            String numStr = nodesIndexS.substring(leftIndex + 1, rightIndex);  // 截取中括号内的字符串
                            num = Integer.parseInt(numStr);  // 将数字字符串转换成int类型
                        }
                        JSONArray jsonArray = obj.getJSONArray(nodes[i]);
                        if(jsonArray==null){
                            jsonArray= new JSONArray();
                        }
                        obj.put(nodes[i].replace("["+num+"]", ""), jsonArray);
                        jsonArray.add(value);
                        continue;
                    }

                    obj.put(nodes[i], value);
                } catch (Exception e) {
                    throw new Exception("Set value error:" + e.getMessage() + ", NodeString:" + obj.toString());
                }
            } else {

                if (nodes[i].contains("[")) {
                    String[] parts = nodes[i].split("\\[");
                    String str=parts[1];
                    String nodesIndexS=str.substring(0, str.length() - 1);
                    int num =Integer.valueOf(nodesIndexS);

                    JSONArray jsonArray = obj.getJSONArray(parts[0]);
                    if(jsonArray==null){
                        jsonArray= new JSONArray();
                    }
                    JSONObject nextObj =null;
                    if(jsonArray.size()>num){
                         nextObj = jsonArray.getJSONObject(num);
                    }
                    if(nextObj==null){
                        nextObj = new JSONObject();
                        nextObj.put(nodes[i + 1], nextObj);
                        jsonArray.add(nextObj);
                    }else{
                        nextObj.put(nodes[i + 1], new JSONObject());
                    }
                    obj.put(parts[0], jsonArray);

                    obj = nextObj;
                    continue;
                }
                JSONObject nextObj = obj.getJSONObject(nodes[i]);
                if (nextObj == null) {
                    nextObj = new JSONObject();
                    obj.put(nodes[i], nextObj);
                }
                obj = nextObj;
            }
        }
    }

}
